package robo;
public class Constant {
    final public static int number_of_object_types = 5;
    // 0 - no messages
    // 1 - messages when RotateTo and RotateAmount finished
    // 2 - messages also when sweep direction is changed

    // robot_option_type
    final public static int SIGNAL=2;
    // 0 - no signal, > 1 - signal to send (e.g. SIGUSR1 or SIGUSR2) 
    final public static int SEND_SIGNAL=0;
    // 0 - false, 1 - true   
    final public static int SEND_ROTATION_REACHED=1;
    // 0 - no messages
    // 1 - messages when RotateTo and RotateAmount finished
    // 2 - messages also when sweep direction is changed
    final public static int USE_NON_BLOCKING=3;
    // 0 - false, 1 - true 
    // This option should always be sent as soon as possible

    // message_to_robot_type 
    final public static int NOOBJECT = -1;
    final public static int ROBOT = 0;
    final public static int SHOT = 1;
    final public static int WALL = 2;
    final public static int COOKIE = 3;
    final public static int MINE = 4;
    final public static int LAST_OBJECT_TYPE = 5;
    // warning_type
    final public static int UNKNOWN_MESSAGE=0;
    final public static int PROCESS_TIME_LOW=1;
    final public static int MESSAGE_SENT_IN_ILLEGAL_STATE=2;
    final public static int UNKNOWN_OPTION=3;
    final public static int OBSOLETE_KEYWORD=4;
    final public static int NAME_NOT_GIVEN=5;
    final public static int COLOUR_NOT_GIVEN=6;
    // game_option_type
    final public static int  ROBOT_MAX_ROTATE=0;
    final public static int  ROBOT_CANNON_MAX_ROTATE=1;
    final public static int  ROBOT_RADAR_MAX_ROTATE=2;
    final public static int  ROBOT_MAX_ACCELERATION=3;
    final public static int  ROBOT_MIN_ACCELERATION=4;
    final public static int  ROBOT_START_ENERGY=5;
    final public static int  ROBOT_MAX_ENERGY=6;
    final public static int  ROBOT_ENERGY_LEVELS=7;
    final public static int  SHOT_SPEED=8;
    final public static int  SHOT_MIN_ENERGY=9;
    final public static int  SHOT_MAX_ENERGY=10;
    final public static int  SHOT_ENERGY_INCREASE_SPEED=11;
    final public static int  TIMEOUT=12;
    final public static int  DEBUG_LEVEL=13;
    // 0 - no debug, 5 - highest debug level
    final public static int  SEND_ROBOT_COORDINATES= 14;
    // 0 - no coordinates, 
    // 1 - coordniates are given relative the starting position
    // 2 - absolute coordinates 
}


