import java.awt.*;
import java.awt.event.*;

public class AWTTest extends Container
{
  ScrollPane treeScroll;
  GridBagLayout gbl;
  Panel abtButtonContainer, defaultContainer, choiceContainer;
  Button insertAbt, chgAbt, deleteAbt;
  Button defaultAbtButton;
  Label defaultAbtLabel, messageLabel, choiceLabel;
  Choice teamChoice;
  //Button b = new Button("            This is a (working) scrollPane!             ");
  Image img = null;

   public static void main(String[] args)
   {
      MenuBar mb = new MenuBar();
    Frame f = new Frame();
    GridBagLayout gbl = new GridBagLayout();
    f.setLayout(gbl);
    f.setTitle("Bin ne native Anwendung!");
    GridBagConstraints gbc = new GridBagConstraints();
    gbc.fill = GridBagConstraints.BOTH;
    AWTTest t = new AWTTest();
    f.setMenuBar(mb);
      for(int i=0; i < 5; i++)
      {
        Menu m = new Menu("Menu"+i);
        for(int n=0; n <10;n++)
        {
          MenuItem mi = new MenuItem("Hello"+n*i);
          m.add(mi);
        }
          mb.add(m);
      }

    gbl.setConstraints(t, gbc);
    f.add(t);
    f.pack();
    f.show();
   }

   public void createMenuBar(MenuBar mb)
   {

   }

  public AWTTest()
  {
    createGui();
  }

  private void createGui()
  {
    gbl = new GridBagLayout();
    setLayout(gbl);

    createWidgets();
    setPrefs();
    setConstraints();
    addWidgets();
  }

  private void createWidgets()
  {
    treeScroll = new ScrollPane(ScrollPane.SCROLLBARS_AS_NEEDED);
    abtButtonContainer = new Panel();
    defaultContainer = new Panel();
    insertAbt = new Button("Add Dep.");
    chgAbt = new Button ("Change Dep.");
    deleteAbt = new Button("Del Dep");
    defaultAbtButton = new Button("Default Department:");
    defaultAbtLabel = new Label("STEYR");
    messageLabel = new Label("Hi there!");
    teamChoice = new Choice();
    choiceLabel = new Label("Auf Team wechseln:");
    choiceContainer = new Panel();

    /*b.addMouseListener(new MouseAdapter()
    {
      public void mouseClicked(MouseEvent e)
      {
        System.out.println("Clicked!");
      }
    });*/
  }

  private void setPrefs()
  {
    treeScroll.setSize(200, 200);

    {
      GridLayout gl = new GridLayout(3,1);
      gl.setVgap(5);
      abtButtonContainer.setLayout(gl);
    }

    {
      GridBagLayout gbl = new GridBagLayout();
      defaultContainer.setLayout(gbl);

      GridBagConstraints gbc = new GridBagConstraints();
      gbc.insets = new Insets(gbc.insets.top, 30, gbc.insets.bottom, gbc.insets.right);
      gbc.anchor = GridBagConstraints.NORTHEAST;
      gbc.fill = GridBagConstraints.BOTH;
      gbc.gridy = 0;
      gbc.gridx = 0;
      gbl.setConstraints(defaultAbtButton, gbc);

      gbc.gridx = 1;
      gbl.setConstraints(defaultAbtLabel, gbc);

      gbc.gridx = 2;
      gbl.setConstraints(messageLabel, gbc);
    }

    {
      teamChoice.add("team1");
      teamChoice.add("Team super3000");

      GridLayout gl = new GridLayout(2, 1);
      gl.setHgap(10);
      choiceContainer.setLayout(gl);
    }
  }

  private void setConstraints()
  {
    GridBagConstraints gbc = new GridBagConstraints();

    Insets oldInsets = (Insets) gbc.insets.clone();
    Insets leftInsets = new Insets(gbc.insets.top, 20, gbc.insets.bottom, gbc.insets.right);
    Insets topInsets = new Insets(10, gbc.insets.left, gbc.insets.bottom, gbc.insets.right);

    gbc.fill = GridBagConstraints.BOTH;
    gbc.gridx = 0;
    gbc.gridy = 0;
    gbc.anchor = GridBagConstraints.NORTHWEST;
    gbl.setConstraints(treeScroll, gbc);

    gbc.insets = leftInsets;
    gbc.gridx = 1;
    gbc.anchor = GridBagConstraints.CENTER;
    gbl.setConstraints(abtButtonContainer, gbc);


    gbc.insets = topInsets;
    gbc.gridy = 1;
    gbc.gridx = 0;
    gbc.gridwidth = 2;
    gbc.anchor = GridBagConstraints.NORTHWEST;
    gbl.setConstraints(defaultContainer, gbc);

    gbc.insets = leftInsets;
    gbc.gridwidth = 1;
    gbc.gridy  = 0;
    gbc.gridx = 3;
    gbc.anchor = GridBagConstraints.CENTER;
    gbl.setConstraints(teamChoice, gbc);


  }

  private void addWidgets()
  {
    Img im = new Img();
    im.setImage(img);

    Panel p = new Panel();
    p.setLayout(new FlowLayout());
    p.add(im);
    treeScroll.add(p);

    this.add(treeScroll);

    abtButtonContainer.add(insertAbt);
    abtButtonContainer.add(chgAbt);
    abtButtonContainer.add(deleteAbt);
    this.add(abtButtonContainer);

    defaultContainer.add(defaultAbtButton);
    defaultContainer.add(defaultAbtLabel);
    defaultContainer.add(messageLabel);
    this.add(defaultContainer);

    choiceContainer.add(choiceLabel);
    choiceContainer.add(teamChoice);
    this.add(choiceContainer);
  }
}

class Img extends Component
{
  Image img;

  public void setImage(Image im)
  {
    this.img = im;
    repaint();
  }

  public void paint(Graphics g)
  {
    if(img!=null)
    {
      g.drawImage(img, 0, 0, this);
    }
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(300, 300);
  }

  public Dimension getMinimumSize()
  {
    return new Dimension(300, 300);
  }
}
