import java.net.*;
import java.util.*;

public class NetworkInterfaceTest
{
public static void main(String[] args)
{
  try
  {
	  Enumeration enm = NetworkInterface.getNetworkInterfaces();
	  while (enm.hasMoreElements())
	  {
		  NetworkInterface aNI = (NetworkInterface) enm.nextElement();
		  System.out.println(aNI.getName());
		  System.out.println(aNI.getDisplayName());
		  Enumeration enmAddr = aNI.getInetAddresses();
		  while (enmAddr.hasMoreElements())
		  {
			  InetAddress aIA = (InetAddress) enmAddr.nextElement();
			  System.out.println(aIA);
		  }
	  }
  }
  catch (Exception e)
  {
	  System.out.println(e.getClass().getName()+": "+e.getMessage());
  }
}
}
