import java.io.*;

public class PrintArgsTest
{
public static void main(String[] args)
    throws IOException
{
    if (args.length>0 && args[0].equalsIgnoreCase("-printargs"))
    {
      System.out.println("Arguments:");
      for (int i=0; i<args.length; ++i)
          System.out.println("--> \""+args[i]+"\"");
      return;
    }

    Process prc =
        Runtime
            .getRuntime()
            .exec
            (
                new String[]
                {
                    "./PrintArgsTest.exe",
                    "-printargs",
                    "addr2line",
                    "-f",
                    "-e",
                    "D:\\Program Files\\thisiscool-gcc\\examples\\PrintArgs\\PrintArgsTest.exe",
                    "A line with \"quotes\". So there. Ha.",
                    "1\" 2 3 4 \"5"
                }
            );

    // Dump the program's output.
    BufferedReader rdr =
        new BufferedReader
        (
            new InputStreamReader(prc.getInputStream())
        );
    for (;;)
    {
        String strLine = rdr.readLine();
        if (strLine == null)
            break;
        System.out.println(strLine);
    }
    rdr.close();
}
}
