import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class ReflectTest
{
public static void main(String[] args) throws Exception
{
	ReflectTest rt = new ReflectTest();
	System.out.println(incrementProperty("number", rt));
}

public final int getNumber()
{
	return n;
}

public final void setNumber(int n)
{
	this.n = n;
}

// private //
private static int incrementProperty(String name, Object obj)
		throws IllegalArgumentException, IllegalAccessException,
		InvocationTargetException, SecurityException, NoSuchMethodException
{
    String prop = Character.toUpperCase(name.charAt(0)) +
        name.substring(1);
    String mname = "get" + prop;
    Class[] types = new Class[] {};
    Method method = obj.getClass().getMethod(mname, types);
    Object result = method.invoke(obj, new Object[0]);
    int value = ((Integer)result).intValue() + 1;
    mname = "set" + prop;
    types = new Class[] { int.class };
    method = obj.getClass().getMethod(mname, types);
    method.invoke(obj, new Object[] { new Integer(value) });
    return value;
}

private int n = 7;
}
