// Invoke from command line as NewStuff.exe
// (WITH extension) to see the stacktrace.
public class NewStuff
{
public static void main(String[] args)
{
    new NewStuff().method1();
}

// private //
private void method1()
{
    method2();
}

private int method2()
{
    method3();
    return 0;
}

private void method3()
{
    new MyInnerClass().innerMethod1();
}

private void method4()
{
    System.out.println(System.getProperty("gnu.gcj.progname"));
    System.out.println(System.getProperty("os.arch"));

    new Object()
    {
    public final String toString()
    {
        throw new RuntimeException("Do stack traces work?");
    }
    }.toString();
}

/////////////////////////////////////////
// inner class MyInnerClass

private class MyInnerClass
{
private void innerMethod1()
{
    new MyInnerInnerClass().innerInnerMethod1();
}

/////////////////////////////////////////
// inner, inner class MyInnerInnerClass

private class MyInnerInnerClass
{
private void innerInnerMethod1()
{
    method4();
}
}

// end inner, inner class MyInnerInnerClass
/////////////////////////////////////////
}

}
