import java.util.*;

public class ThreadHandlesTest {

public void createThread(final int j){
    		Runnable run = new Runnable(){
    			public void run(){
			  System.out.println("I am thread number "+j);
			  tsleep(2000,null);
			  System.out.println("Exiting thread number "+j);
    			};
    		};
    		try{
    		  new Thread(run).start();
    		}catch(Exception e){
    		  System.out.println(e.toString());
    		};
};

public void test(){
	for (int i = 0;i<30;i++){
		createThread(i);
	};
};

public static void tsleep(long t,String s){
    if (s!=null)
	System.out.println(s);
    try{
    	Thread.sleep(t);
    }catch(Exception e){
    	System.out.println(e.toString());
    }
};


public static void main(String[] args) {
   tsleep(5000,"Begin test : look at handles resource on Task Manager before starting ");
    ThreadHandlesTest test = new ThreadHandlesTest();
    test.test();
    tsleep(10000,"executing garbage collector ...");
    Runtime.getRuntime().runFinalization();
    Runtime.getRuntime().gc();
    tsleep(10000,"End test : now look again at handles resource on Task Manager before exiting ");
}

};

